/**********************************************************************
 * $Id: BsbInfo.java 8765 2006-11-15 00:08:29Z jjdelcerro $
 *
 * Name:     BsbInfo.java
 * Project:  JGDAL. Interface java to gdal (Frank Warmerdam).
 * Purpose:  This class contains the bsb file information. 
 * Author:   Nacho Brodin, brodin_ign@gva.es
 *
 **********************************************************************/
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/

package es.gva.cit.jbsb;

import java.io.*;

/**
 * Contiene los datos de cabecera del fichero
 * BSB cargados desde la libreria de C.
 * 
 * @author	Nacho Brodin <brodin_ign@gva.es>
 */

public class BsbInfo{
	
    public int nXSize;
    public int nYSize;
    public int nPCTSize;
    public short[] pabyPCT;
    public String[] papszHeader;
    public int[] panLineOffset;
    public int nColorSize;
    public int nVersion; 
    public int bNO1;
    public int bNewFile;
    public int nLastLineWritten;
    public long cPtr;
    /**
     * Crea los vectores de la longitud especificada por par&aacute;metros.
     * @param pPCT	longitud de pabyPCT
     * @param pH	longitud de papszHeader
     * @param pLO	longitud de panlineOffset
     */
    
    public void reserva(int pPCT,int pH,int pLO){
    	
    	//Reserva de memoria para los vectores

    	pabyPCT = new short[pPCT];
    	papszHeader = new String[pH];
    	panLineOffset = new int[pLO];
   
    }
    
    /**
     * Obtiene la longitud del vector de Strings papszHeader
     * @return Entero con la longitud del vector de Strings papszHeader
     */
    
    public int len_papszHeader(){
    	return papszHeader.length;
    }
    
   
}